unit untDemo;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, untvaluearea, ExtCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    btnData: TButton;
    btn1: TButton;
    btn2: TButton;
    ScrollBar1: TScrollBar;
    Label1: TLabel;
    Panel2: TPanel;
    btnClear: TButton;
    Timer1: TTimer;
    btnRandom: TButton;
    ScrollBar2: TScrollBar;
    Label2: TLabel;
    Timer2: TTimer;
    procedure btnDataClick(Sender: TObject);
    procedure btn1Click(Sender: TObject);
    procedure btn2Click(Sender: TObject);
    procedure ScrollBar1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btnClearClick(Sender: TObject);
    procedure btnRandomClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Panel2Resize(Sender: TObject);
    procedure ScrollBar2Change(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    data : TValueData;
    area1 : TValueArea;
    area2 : TValueArea;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.btnDataClick(Sender: TObject);
begin
  if Assigned(data) then
    begin
      timer1.Enabled := false;
      timer2.Enabled := false;
      data.SaveOptions;
      data.SaveColors;
      data.free;
      data := Nil;
      btnData.caption := 'Create data';
      btnClear.enabled := false;
      btnRandom.enabled := false;
    end
  else
    begin
      data := TValueData.Create(Self);
      data.AddItem(1, 'First', 'This is the first item', '%3.0f');
      data.AddItem(2, 'Second', 'This is the second item', '%2.1f');
      data.RestoreOptions;
      data.RestoreColors;
      btnData.caption := 'Free data';
      btnClear.enabled := true;
      btnRandom.enabled := true;
    end;
end;

procedure TForm1.btn1Click(Sender: TObject);
begin
  if Assigned(area1) then
    begin
      area1.SaveItems;
      area1.free;
      area1 := Nil;
      btn1.caption := 'Create 1';
    end
  else
    begin
      area1 := TValueArea.Create(Panel2);
      area1.data := data;
      area1.Align := alTop;
      area1.IniSection := 'Area1';
      area1.RestoreItems;
      btn1.caption := 'Free 1';
    end;
  Panel2Resize(Sender);
end;

procedure TForm1.btn2Click(Sender: TObject);
begin
  if Assigned(area2) then
    begin
      area2.SaveItems;
      area2.free;
      area2 := Nil;
      btn2.caption := 'Create 2';
    end
  else
    begin
      area2 := TValueArea.Create(Panel2);
      area2.data := data;
      area2.Align := alBottom;
      area2.IniSection := 'Area2';
      area2.RestoreItems;
      btn2.caption := 'Free 2';
    end;
  Panel2Resize(Sender);
end;

procedure TForm1.ScrollBar1Change(Sender: TObject);
begin
  Label1.Caption := IntToStr(ScrollBar1.Position);
  if Assigned(data) then
    data.SetData(1, ScrollBar1.Position);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  ScrollBar1Change(Self);
  ScrollBar2Change(Self);
end;

procedure TForm1.btnClearClick(Sender: TObject);
begin
  if Assigned(data) then
    data.Clear;
end;

procedure TForm1.btnRandomClick(Sender: TObject);
begin
  if timer1.Enabled then
    begin
      timer1.Enabled := false;
      timer2.Enabled := false;
      btnRandom.caption := 'Random';
    end
  else
    begin
      timer1.Enabled := true;
      timer2.Enabled := true;
      btnRandom.caption := 'Manual';
    end;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var
  iOffset : Integer;
begin
  iOffset := Random(50) - 25;
  with ScrollBar1 do
    if ((Position + iOffset) > Max) then
      Position := Max
    else
      if ((Position + iOffset) < Min) then
        Position := Min
      else
        Position := Position + iOffset;
end;

procedure TForm1.Panel2Resize(Sender: TObject);
begin
  if Assigned(area1) then
    area1.Height := (Panel2.ClientHeight - Panel2.BevelWidth * 4) div 2;
  if Assigned(area2) then
    area2.Height := (Panel2.ClientHeight - Panel2.BevelWidth * 4) div 2;
end;

procedure TForm1.ScrollBar2Change(Sender: TObject);
begin
  Label2.Caption := FloatToStr(ScrollBar2.Position / 10);
  if Assigned(data) then
    data.SetData(2, ScrollBar2.Position / 10);
end;

procedure TForm1.Timer2Timer(Sender: TObject);
var
  iOffset : Integer;
begin
  iOffset := Random(20) - 10;
  with ScrollBar2 do
    if ((Position + iOffset) > Max) then
      Position := Max
    else
      if ((Position + iOffset) < Min) then
        Position := Min
      else
        Position := Position + iOffset;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  if Assigned(data) then
    begin
      data.SaveOptions;
      data.SaveColors;
    end;
  if Assigned(area1) then
    area1.SaveItems;
  if Assigned(area2) then
    area2.SaveItems;
end;

end.
 